# coding: utf-8

"""
    FeersumNLU API

    This is the HTTP API for Feersum NLU. See https://github.com/praekelt/feersum-nlu-api-wrappers for examples of how to use the API.

    OpenAPI spec version: 2.0.3
    Contact: nlu@feersum.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

# import models into sdk package
from .models.class_label import ClassLabel
from .models.class_label_list import ClassLabelList
from .models.class_label_pair import ClassLabelPair
from .models.create_details import CreateDetails
from .models.dashboard_detail import DashboardDetail
from .models.dashboard_model_detail import DashboardModelDetail
from .models.date import Date
from .models.date_list import DateList
from .models.duckling_ent_create_details import DucklingEntCreateDetails
from .models.duckling_instance_detail import DucklingInstanceDetail
from .models.duckling_instance_detail_list import DucklingInstanceDetailList
from .models.entity import Entity
from .models.entity_list import EntityList
from .models.instance_detail import InstanceDetail
from .models.instance_detail_list import InstanceDetailList
from .models.labeled_word_manifold import LabeledWordManifold
from .models.labelled_text_sample import LabelledTextSample
from .models.labelled_text_sample_list import LabelledTextSampleList
from .models.lr4_create_details import Lr4CreateDetails
from .models.lr4_instance_detail import Lr4InstanceDetail
from .models.lr4_instance_detail_list import Lr4InstanceDetailList
from .models.new_word import NewWord
from .models.new_word_list import NewWordList
from .models.regex_ent_create_details import RegexEntCreateDetails
from .models.regex_instance_detail import RegexInstanceDetail
from .models.regex_instance_detail_list import RegexInstanceDetailList
from .models.scored_label import ScoredLabel
from .models.scored_label_list import ScoredLabelList
from .models.sentiment import Sentiment
from .models.similarity_ent_create_details import SimilarityEntCreateDetails
from .models.similarity_instance_detail import SimilarityInstanceDetail
from .models.similarity_instance_detail_list import SimilarityInstanceDetailList
from .models.text_input import TextInput
from .models.total_samples import TotalSamples
from .models.train_details import TrainDetails
from .models.word_and_distance import WordAndDistance
from .models.word_and_distance_list import WordAndDistanceList
from .models.word_and_threshold import WordAndThreshold

# import apis into sdk package
from .apis.dashboard_api import DashboardApi
from .apis.date_parsers_api import DateParsersApi
from .apis.duckling_entity_extractors_api import DucklingEntityExtractorsApi
from .apis.faq_matchers_api import FaqMatchersApi
from .apis.intent_classifiers_api import IntentClassifiersApi
from .apis.lr4_language_recognisers_api import Lr4LanguageRecognisersApi
from .apis.regex_entity_extractors_api import RegexEntityExtractorsApi
from .apis.sentiment_detectors_api import SentimentDetectorsApi
from .apis.similarity_entity_extractors_api import SimilarityEntityExtractorsApi
from .apis.text_classifiers_api import TextClassifiersApi
from .apis.word_manifolds_api import WordManifoldsApi

# import ApiClient
from .api_client import ApiClient

from .configuration import Configuration

configuration = Configuration()
